
//--------------------------------------------------------------------
//     此代码由liquid模板自动生成  byzhouhang 20240909
//     生成时间 2025-06-09 02:09:09Z 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------
using IRaCIS.Core.Domain.Models;
using Microsoft.AspNetCore.Mvc;
using IRaCIS.Core.Application.Interfaces;
using IRaCIS.Core.Infrastructure.Extention;
using System.Threading.Tasks;
using IRaCIS.Core.Infra.EFCore;
using IRaCIS.Core.Application.Service.DTO;
using IRaCIS.Core.Application.MassTransit.Command;
namespace IRaCIS.Core.Application.Service;

/// <summary>
/// 项目历史记录文件服务
/// </summary>
[ApiExplorerSettings(GroupName = "FileRecord")]
public class TrialHistoryRecordFileService(IRepository<TrialHistoryRecordFile> _trialHistoryRecordFileRepository,
                                  IMapper _mapper, IUserInfo _userInfo, IStringLocalizer _localizer): BaseService, ITrialHistoryRecordFileService
{

    /// <summary>
    /// 获取稽查记录文件列表
    /// </summary>
    /// <param name="inQuery"></param>
    /// <returns></returns>
    [HttpPost]
	public async Task<PageOutput<TrialHistoryRecordFileView>>  GetTrialHistoryRecordFileList(TrialHistoryRecordFileQuery inQuery)
	{
			
		    var trialHistoryRecordFileQueryable =_trialHistoryRecordFileRepository
			.WhereIf(inQuery.TrialRecordId!=null,x=>x.TrialRecordId==inQuery.TrialRecordId)
            .WhereIf(inQuery.TrialFileTypeId != null, x => x.TrialFileTypeId == inQuery.TrialFileTypeId)
             .WhereIf(inQuery.FileName.IsNotNullOrEmpty(), x => x.FileName.Contains(x.FileName))
                                        .ProjectTo<TrialHistoryRecordFileView>(_mapper.ConfigurationProvider);

            var pageList= await trialHistoryRecordFileQueryable.ToPagedListAsync(inQuery);

        return pageList;
	}

    /// <summary>
    /// 批量新增稽查记录文件
    /// </summary>
    /// <param name="inDto"></param>
    /// <returns></returns>
    [HttpPost]
    public async Task<IResponseOutput> BatchAddTrialHistoryRecordFile(List<TrialHistoryRecordFileAddOrEdit> inDto)
    {
        List<TrialHistoryRecordFile> entities = _mapper.Map<List<TrialHistoryRecordFile>>(inDto);
        await _trialHistoryRecordFileRepository.AddRangeAsync(entities);

        await _trialHistoryRecordFileRepository.SaveChangesAsync();
        return ResponseOutput.Ok(true);
    }

    /// <summary>
    /// 新增或修改稽查记录文件
    /// </summary>
    /// <param name="addOrEditTrialHistoryRecordFile"></param>
    /// <returns></returns>
    [HttpPost]
    public async  Task<IResponseOutput> AddOrUpdateTrialHistoryRecordFile(TrialHistoryRecordFileAddOrEdit addOrEditTrialHistoryRecordFile)
	{
		    //  在此处拷贝automapper 映射
			  
         


			var entity = await _trialHistoryRecordFileRepository.InsertOrUpdateAsync(addOrEditTrialHistoryRecordFile, true);

        return ResponseOutput.Ok(entity.Id.ToString());
		
	}

    /// <summary>
    /// 删除稽查记录文件
    /// </summary>
    /// <param name="trialHistoryRecordFileId"></param>
    /// <returns></returns>
	[HttpDelete("{trialHistoryRecordFileId:guid}")]
    public async Task<IResponseOutput> DeleteTrialHistoryRecordFile(Guid trialHistoryRecordFileId)
	{
			var success = await _trialHistoryRecordFileRepository.DeleteFromQueryAsync(t => t.Id == trialHistoryRecordFileId,true);
            return ResponseOutput.Ok();
	}
      
}



